%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Section G: Test functions for bg_residue;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Sec_G = bg_Sec_G(Sec_A)
    global  G_PROG ;      
    global  G_FID ;
    global  G_DEBUG;
    G_FID = fopen(sprintf('test/Sec_G.log',G_PROG), 'w');
    Sec_G.a=1;%% temp value -- must change
    if G_FID
G_DEBUG=0;
        fprintf(G_FID,'Octave program "%s.m" using "bg_Sec_G.m":\n',G_PROG);
        fprintf(      '\nStarting test functions in "bg_residue.m".\n' );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,' Starting test functions in "bg_residue.m".\n'  );
        fprintf(       'Using "bg_Sec_G.m" to run "test    residue":  ');
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,' Using "bg_Sec_G.m" to run "test residue".\n'   );
        test residue;
        fprintf(       'Using "bg_Sec_G.m" to run "test bg_residue":  ');
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,' Using "bg_Sec_G.m" to run "test bg_residue".\n');
        test bg_residue
        fprintf(       'Completed test functions in "bg_residue.m".\n' );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,' Completed test functions in "bg_residue.m".\n' );
        %%----------------------------------------------------------------
        fprintf(      'Starting details of a new test function.\n'     );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'               );
        fprintf(G_FID,' Starting details of a new test function.\n'    );
        fprintf(G_FID,'Inputs Sec_A.r,  Sec_A.p, Sec_A.k, and Sec_A.e are:\n');
        bg_print('Sec_A.r',Sec_A.r);
        bg_print('Sec_A.p',Sec_A.p);
        bg_print('Sec_A.k',Sec_A.k);
        bg_print('Sec_A.e',Sec_A.e);
        fprintf(G_FID,'Running [b, a] = bg_residue (Sec_A.r, Sec_A.p, Sec_A.k, Sec_A.e);\n');
        [b, a] = bg_residue (Sec_A.r, Sec_A.p, Sec_A.k, Sec_A.e);
        fprintf(G_FID,'Outputs b and a are:\n');
        bg_print('      b',b);
        bg_print('      a',a);
        fprintf(G_FID,'For comparison inputs from Sec_A are:\n');
        bg_print('Sec_A.b',Sec_A.b);
        bg_print('Sec_A.a',Sec_A.a);
        %%-------------------------------------------------------
G_DEBUG=1;
        z1=+7.0372976777e+06;
        p1=-3.1415926536e+09;
        p2=-4.9964813512e+08;
        r1=-(1+z1/p1)/(1-p1/p2)/p2/p1  ;
        r2=-(1+z1/p2)/(1-p2/p1)/p2/p1  ;
        r3=(1+(p2+p1)/p2/p1*z1)/p2/p1  ;
        r4=z1/p2/p1                    ; 
        r=[r1;r2;r3;r4];
        p=[p1;p2;0;0];
        k=[];
        e=[1;1;1;2];
        b=[1,z1];
        a=[1,-(p1+p2),p1*p2,0,0];
        [br, ar] = bg_residue (r, p, k, e);
        assert ((abs (br - b) < 1e-8
              && abs (ar - a) < 1e-8));
        %%-------------------------------------------------------
        fprintf(      'Completed details of a new test function.\n'  );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'             );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'             );
        fprintf(G_FID,' Completing details of a new test function.\n');
        fclose(G_FID);
   endif
endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
