function bg_print(n,r)

global	G_FID;
len_r=length(r);
[nr,nc]=size(r);
mode=0;
if ((nr==1)&&(nc==1)) mode=0; endif %% Constant 
if ((nr >1)&&(nc >1)) mode=0; endif %% Matrix
if ((nr==1)&&(nc >1)) mode=1; endif %% Row Vector
if (mode==0)  %% Constant or Column Vector or Matrix
    fprintf(G_FID,'%s=\\\n[',n);
    for i=1:nr
        for j=1:nc
            x_real=real(r(i,j));
            x_imag=imag(r(i,j));     fprintf(G_FID,'%+17.10e' ,x_real);
            if (abs(x_imag) > 0)     fprintf(G_FID,'%+17.10ei',x_imag);endif
            if (i<nr+1)&&(j<nc)      fprintf(G_FID,',')               ;endif
            if (abs(x_imag) > 0)     
                if (!mod(j,2))&&(j!=nc) 
                    fprintf(G_FID,'\\\n                                     ')            
                endif
            else                     
                if (!mod(j,4))&&(j!=nc) 
                fprintf(G_FID,'\\\n                   ');
                endif
            endif
        endfor
        if (i<nr)                    fprintf(G_FID,';\n ')            ;endif
    endfor
    fprintf(G_FID,'];\n');
else %% Row Vector
    if (nc<6) fprintf(G_FID,"%s=[",n);
    else      fprintf(G_FID,"transpose(%s)=\\\n[",n);endif
    for j=1:nc
        x_real=real(r(1,j));
        x_imag=imag(r(1,j));    fprintf(G_FID,'%+17.10e' ,x_real);
        if (abs(x_imag) > 0)    fprintf(G_FID,'%+17.10ei',x_imag)  ;endif
        if (j<nc)
            if  (nc<6)  fprintf(G_FID,',');  
            else        fprintf(G_FID,';\n ') ;endif
        endif             
    endfor
    fprintf(G_FID,'];\n');
endif
