%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Section H: Test functions for bg_residuez;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Sec_H = bg_Sec_H(Sec_B)
    global  G_PROG ;      
    global  G_FID ;
    global  G_DEBUG;
    G_FID = fopen(sprintf('test/Sec_H.log',G_PROG), 'w');
    Sec_H.a=1;%% temp value -- must change
    if G_FID
G_DEBUG=0;
        fprintf(G_FID,'Octave program "%s.m" using "bg_Sec_H.m":\n',G_PROG);
        fprintf(      '\nStarting test functions in "bg_residuez.m".\n'   );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,' Starting test functions in "bg_residuez.m".\n'    );
        fprintf(       'Using "bg_Sec_H.m" to run "test    residuez": '   );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,' Using "bg_Sec_H.m" to run "test residuez".\n'     );
        test residuez;
        fprintf(       'Using "bg_Sec_H.m" to run "test bg_residuez": '   );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,' Using "bg_Sec_H.m" to run "test bg_residuez".\n'  );
        test bg_residuez
        fprintf(       'Completed test functions in "bg_Sec_H.m".\n'      );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'                  );
        fprintf(G_FID,' Completed test functions in "bg_Sec_H.m".\n'      );
        %%----------------------------------------------------------------
        fprintf(      'Starting details of a new test function.\n');
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx');
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx');
        fprintf(G_FID,' Starting details of a new test function.\n');
        a=Sec_B.a;
        b=Sec_B.b;
        fprintf(G_FID,'Inputs a and b are from Section B.\n');
        bg_print('b',b);
        bg_print('a',a);
        fprintf(G_FID,'------------------------------------ Into [r,p,k,e]=bg_residuez(b,a).\n');
        [r,p,k,e] = bg_residuez(b,a);
        fprintf(G_FID,'---------------------------------- Out of [r,p,k,e]=bg_residuez(b,a).\n');
        fprintf(G_FID,'Final outputs are r, p, k and e:\n');
        bg_print('r',r);
        bg_print('p',p);
        bg_print('k',k);
        bg_print('e',e);
	fprintf(G_FID,'Inputs Sec_B.r, Sec_B.p Sec_B.k, and Sec_B.e are:\n');
	bg_print('Sec_B.r',Sec_B.r);
	bg_print('Sec_B.p',Sec_B.p);
	bg_print('Sec_B.k',Sec_B.k);
	bg_print('Sec_B.e',Sec_B.e);
        %%-------------------------------------------------------
G_DEBUG=1;
        z1=+7.0372976777e+06;
        p1=-3.1415926536e+09;
        p2=-4.9964813512e+08;
        r1=-(1+z1/p1)/(1-p1/p2)/p2/p1  ;
        r2=-(1+z1/p2)/(1-p2/p1)/p2/p1  ;
        r3=(1+(p2+p1)/p2/p1*z1)/p2/p1  ;
        r4=z1/p2/p1                    ; 
        fi= 1.05e+08     ;
        T =1/fi          ;
        p1=exp(p1*T);
        p2=exp(p2*T);
        p3=1;
        p4=1;
        p =[p1;p2;p3;p4];
        r4=r4*T;
	r3=r3-r4;
        r =[r1;r2;r3;r4];
        m=[       1     ,     1     ,     1         ,     1	    ;
               -(2+p2)  ,  -(2+p1)  , -(1+p1+p2)    ,  -(p1+p2)     ;
              +(1+2*p2) , +(1+2*p1) , (p1*p2+p1+p2) ,   +p1*p2      ;
                 -p2    ,   -p1     , -p1*p2        ,     0	    ];
        a1=1.00;
        a2=-(2+p1+p2);
        a3=1+2*(p1+p2)+p1*p2;
        a4=-(p1+p2+2*p1*p2);
        a5=p2*p1;
        a =[a1,a2,a3,a4,a5];
        b=[m*r]';
        k=[];
        e=[1;1;1;2];
        [rx,px,kx,ex] = bg_residuez(b,a);
        assert ((abs (rx - r) < 1e-8
              && abs (px - p) < 1e-8
              && isempty (kx)
              && ex == e));
        fprintf(      'Completing details of a new test function.\n' );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'             );
        fprintf(G_FID,'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'             );
        fprintf(G_FID,' Completing details of a new test function.\n');
   endif
endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
